#include <Agents/Agent.hpp>
#include <Agents/Perception/Perception.hpp>
#include <Environment/PictureEnvironment.hpp>

Agent::Agent()
{
}

int PERCEPTION_SIZE = 2;

Agent::Agent(PictureEnvironment* iEnvironment)
{
	//uint32_t WHITE = 0xFFFFFFFF;
	fEnvironment = iEnvironment;
	fCurrentPerception = Perception(PERCEPTION_SIZE, PERCEPTION_SIZE);
	//fColor = sf::Color(rand() % 0xFFFFFFFFFFFF);
	uint32_t vRand = (((double)rand() / RAND_MAX) * 0xFFFFFFFFU);

	fColor = sf::Color(vRand);
	//fColor = sf::Color(((rand() % fColor.Red.toInteger())));
	fXPos = iEnvironment->getWidth() / 2;
	fYPos = iEnvironment->getHeight() / 2;
}

void Agent::loop()
{
	fEnvironment->getPerception(&fCurrentPerception, fXPos, fYPos);
	move();
	this->paint();
}

int MOVESIZE = 10;

void Agent::move()
{
	fXPos += ((double)rand() / RAND_MAX) * MOVESIZE - ((double)MOVESIZE / 2);
	fYPos += ((double)rand() / RAND_MAX) * MOVESIZE - ((double)MOVESIZE / 2);
}

void Agent::paint()
{
	fEnvironment->paint(fXPos, fYPos, fColor);
}