#include <Agents/Agent.hpp>
#include <Environment/PictureEnvironment.hpp>

RepaintAgent::RepaintAgent(PictureEnvironment* iEnvironment) :
	Agent(iEnvironment)
{
	int vWidth = fEnvironment->getWidth();
	int vHeight = fEnvironment->getHeight();

	fXPos = (((double)rand() / RAND_MAX) * vWidth);
	fYPos = (((double)rand() / RAND_MAX) * vHeight);

	fColor = sf::Color(fEnvironment->getCell(fXPos, fYPos));
}

int MOVESIZE_PAINT = 10;

void RepaintAgent::move()
{
	double vRand = rand() % (MOVESIZE_PAINT + 1);
	fXPos += vRand - MOVESIZE_PAINT / 2;
	vRand = rand() % (MOVESIZE_PAINT + 1);
	fYPos += vRand - MOVESIZE_PAINT / 2;
}

int BRUSH_SIZE_PAINT = 20;

void RepaintAgent::paint()
{
	int vHalfBrush = BRUSH_SIZE_PAINT / 2;
	int vXLoopIndex = fXPos - vHalfBrush;
	int vYLoopIndex = fYPos - vHalfBrush;
	while (vXLoopIndex < (fXPos + vHalfBrush))
	{
		while (vYLoopIndex < fYPos + vHalfBrush)
		{
			fEnvironment->paint(vXLoopIndex, vYLoopIndex, fColor);
			vYLoopIndex++;
		}
		vYLoopIndex = fYPos - vHalfBrush;
		vXLoopIndex++;
	}
}

void RepaintAgent::loop()
{
	fEnvironment->getPerception(&fCurrentPerception, fXPos, fYPos);
	move();
	this->paint();
}
